package com.sghe.common.cdo.spring.util;

import org.eclipse.emf.cdo.server.IRepository;
import org.eclipse.emf.cdo.server.IRepositoryProvider;

import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;

/**
 * @author PhaneeshN
 */
public class ContextRepositoryProvider implements IRepositoryProvider,
		ApplicationContextAware {
	private ApplicationContext context;

	public ContextRepositoryProvider() {
	}

	public void setApplicationContext(ApplicationContext context)
			throws BeansException {
		this.context = context;
	}

	public IRepository getRepository(String name) {
		Object repository = context.getBean(name, IRepository.class);
		if (repository == null) {
			throw new IllegalStateException("Repository not found: " + name);
		}

		return (IRepository) repository;
	}
	
	
}
